----------------------------------------
-- Extremely Simple Text-mode Dialogs --
----------------------------------------
	 
include graphics.e -- color names
include dll.e

without warning

constant COLORS = 1,  FGND = 1, BKGND = 2,   -- box structure
	 COORDS = 2,  ROW = 1, COL = 2,
	 SIZE   = 3,  HEIGHT = 1, WIDTH = 2, MINH = 4, MINW = 8,    
	 STYLE  = 4,      
	 SHADOW = 5,
	 HINT   = 6,
	 HINTCOLORS = 7,
	 BUFFER = 8
	 
global constant SGL = 1, DBL = 2, DHL = 3, DVL = 4, NONE = 5  -- border styles
constant up = 259, dn = 258, left = 260, right = 261, ENTER = 10, ESC = 27, SP = 32, 
	 pgup = 339, pgdn = 338, home = 262, endd = 360, insert = 331, bksp = 263

global atom SCREEN_BKGND

global atom LIST_KEY

sequence DefaultBox
	 DefaultBox = {{BRIGHT_WHITE,BLUE},  -- default colors
		       {1,1},                -- coordinates top left corner
		       {5,10},               -- box size
			SGL,                 -- single line border
			1,                   -- light shadow
			"Press any key...",  -- hint text
			{GREEN,BLACK},       -- hint colors
			{}}                  -- buffer for save screen

--to accomodate usage in xterm or konsole that hasn't been set to 25 lines
--if you know it has, then set it to 25, to appear at bottom of screen
integer SCREEN_LINES
	SCREEN_LINES = 24
global sequence vid_conf

---------------------------------------------------------------------------------------------------------------------
--NEW - use stdlib ncurses shared lib to get number of lines (could prob do this direct, but this is easier for now!)
-- uses ncurses LINES variable, defined at run time - couldn't for the life of me get environment variable to work
--atom lines_lib
--integer line_count

--open the library
--lines_lib = open_dll("./lines.so")
--if lines_lib = NULL then
    --puts(2, "Couldn't open mylib.so\n")
    --abort(1)
--end if

--the c function
--line_count = define_c_func(lines_lib, "line_count", {C_INT}, C_INT)
--if line_count = -1 then
    --puts(1, "Couldn't find \"sum\" function\n")
    --abort(1)
--end if

--get the line count
--SCREEN_LINES = c_func(line_count, {0})

--Darn, just found this afterwards!
vid_conf = video_config()
SCREEN_LINES = vid_conf[VC_LINES]

---------------------------------------------------------------------------------------------------------------------
global procedure printat(sequence coords, sequence text)
 position(coords[1],coords[2])
 puts(1,text)    
end procedure

global procedure printcolor(sequence coords, sequence colors, sequence text)
 text_color(colors[1])
 bk_color(colors[2])
 printat(coords,text)   
end procedure        

global function limit (atom n, sequence limits)
 if n < limits[1] then n = limits[1]
 elsif n > limits[2] then n = limits[2]
 end if
 return n
end function 

global function pad (sequence s, atom width)
while length(s) < width do s = s & ' '
end while
return s
end function

global function delete (sequence s, atom loc, atom len)
return s[1..loc-1] & s[loc+len..length(s)]
end function   

procedure MoveCursor(sequence coords)
position(coords[ROW],coords[COL])    
end procedure                       

function SaveBkgnd(object box)
   cursor(NO_CURSOR)
   box[COORDS] = get_position()
-- box[BUFFER] = save_text_image(box[COORDS],box[COORDS]+box[SIZE]+2)
   cursor(UNDERLINE_CURSOR)
 return box
end function                  

global procedure RestoreBkgnd(object box)
    MoveCursor(box[COORDS])
--  display_text_image(box[COORDS],box[BUFFER])
end procedure            
-------------------------------< BOX >-----------------------------------
	 
constant Lines = {{'','','','','',''}, -- single line borders
		  {'','','','','',''}, -- double line borders
		  {'','','','','',''}, -- double horizontal
		  {'','','','','',''}, -- double vertical
		  {' ',' ',' ',' ',' ',' '}} -- none
		  
constant Divider = {{'','',''}, -- single style divider line
		    {'','',''},
		    {'','',''}, -- double horizontal
		    {'','',''},
		    {' ',' ',' '}}

constant Shadow = {'','',''}  -- 3 different shadow backgrounds
		  
constant TL = 1, HL = 2, TR = 3, VL = 4, BL = 5, BR = 6

global function DisplayBox(sequence box)
sequence topline, botline, midline, divline, rshad, bshad, char
atom row, col, x, y
 box = SaveBkgnd(box)
 row = box[COORDS][ROW] col = box[COORDS][COL]
 x = box[SIZE][WIDTH] y = box[SIZE][HEIGHT]  
 text_color(box[COLORS][FGND])
 bk_color(box[COLORS][BKGND])
 cursor(NO_CURSOR) 

-- grab the area to be shadowed:  
--   rshad = save_text_image({row+1,col+x+2},{row+y+1,col+x+2})
--   bshad = save_text_image({row+y+1,col+1},{row+y+1,col+x+1})
     
-- select the border style to use: 
   char = Lines[box[STYLE]]
  
-- build the borders:
   topline = char[TL] & repeat(char[HL],x) & char[TR]
   botline = char[BL] & repeat(char[HL],x) & char[BR]
   midline = char[VL] & repeat(' ',x) & char[VL]
   char = Divider[box[STYLE]]
   divline = char[1] & repeat(char[2],x) & char[3]

-- draw the borders: 
   printat({row,col}, topline)  
   for i = 1 to y do
     printat({row+i,col}, midline)  
   end for          
   printat({row + 2,col}, divline)
   printat({row + y,col}, botline)  

-- draw the shadows:
-- if box[SHADOW] > 0 then  
--    position(20,1)
--    for i = 1 to length(rshad) do
--        rshad[i][2] = rshad[i][2] / 16
--        rshad[i][1] = Shadow[box[SHADOW]]
--    end for  
--    for i = 2 to length(bshad[1]) by 2 do
--        bshad[1][i] = bshad[1][i] / 16
--        bshad[1][i-1] = Shadow[box[SHADOW]]
--    end for

--    display_text_image({row+1,col+x+2},rshad)
--    display_text_image({row+y+1,col+1},bshad)
-- end if

 MoveCursor(box[COORDS]) -- restore cursor to start
 cursor(UNDERLINE_CURSOR)  
 return box
end function                                               

------------------------------------------------------------                    
global procedure SetColors(atom fgnd, atom bkgnd)
  DefaultBox[COLORS] = {fgnd,bkgnd}
end procedure                          

global procedure SetSize(atom rows, atom cols)
 DefaultBox[SIZE] = {rows,cols}    
end procedure           

global procedure SetStyle(atom style)
 DefaultBox[STYLE] = style    
end procedure                          

global procedure SetHint(sequence hint)
 DefaultBox[HINT] = hint   
end procedure                          

global procedure DisplayHint(sequence hint)
 printcolor({SCREEN_LINES,2},DefaultBox[HINTCOLORS],repeat(' ',78))
 printcolor({SCREEN_LINES,3},DefaultBox[HINTCOLORS],hint)    
end procedure                       

procedure DisplayList(sequence coords, sequence colors, sequence list, atom default)
   for i = 1 to length(list) do
     if i = default then
       printcolor(coords+{i,0},{colors[2],colors[1]},list[i])   
     else
       printcolor(coords+{i,0},colors,list[i]) 
     end if  
   end for
end procedure                                                     

global function GenericBox (sequence title, sequence msg)
object msgbox
  msgbox = DefaultBox -- copy defaults
  msgbox = DisplayBox(msgbox)                         
  printat(msgbox[COORDS]+{1,1},title)
  DisplayList(msgbox[COORDS]+{2,1},msgbox[COLORS],msg,0)
  return msgbox      
end function

global procedure MessageBox (sequence title, sequence msg)
object box
 box = GenericBox(title,msg)  
end procedure
     
global procedure Notify (sequence title, sequence msg)
object box
  box = GenericBox(title,msg)  
  DisplayHint( "Press any key...")
  while get_key() = -1 do -- wait for keypress 
  end while 
  RestoreBkgnd(box)                                           
end procedure

global function Select (sequence title, atom default, sequence items)
object box, hilite
atom key, selection 
 box = GenericBox(title,items)  
 DisplayHint( "Select with up/dn arrows - press enter - esc to cancel" )
 key = -1 selection = default                                 
 cursor(NO_CURSOR)
 DisplayList(box[COORDS]+{2,1},box[COLORS],items,selection)
 while key != ENTER do 
   key = get_key()    
   if key = up then 
     selection = limit(selection - 1,{1,length(items)})      
   elsif key = dn then 
      selection = limit(selection + 1,{1,length(items)})  
   elsif key = pgup then  selection = 1
   elsif key = pgdn then  selection = length(items)
  elsif key = left then 
      key = 27
   elsif key = right then 
      key = 13 
   elsif key = ESC then 
      selection = -1 
      exit  
   end if   
   if key != -1 then DisplayList(box[COORDS]+{2,1},box[COLORS],items,selection)
   end if
 end while         
 RestoreBkgnd(box)
 cursor(UNDERLINE_CURSOR)
return selection
end function

global function CheckBox(sequence title, sequence items)
object box, selecteditems   
atom key, selection
 for i = 1 to length(items) do
     items[i] = "[ ] "&items[i]
 end for
 box = GenericBox(title,items)
 DisplayHint("Select with up/dn arrows, toggle with spacebar, enter when finished")    
 key = -1  selection = 1
 MoveCursor(box[COORDS]+{selection+2,2})
 while key != 13 do
       key = get_key()
       if key != -1 then
	  MoveCursor(box[COORDS]+{selection+2,2}) 
       end if
       if key = SP then
	if items[selection][2] = 'X' then
	   items[selection][2] = ' ' 
	else   
	  items[selection][2] = 'X'   
	end if  
	  printcolor(box[COORDS]+{selection+2,1},box[COLORS],items[selection])                               
	  MoveCursor(box[COORDS]+{selection+2,2})
       elsif key = up then 
	  selection = limit(selection - 1,{1,length(items)})      
	  MoveCursor(box[COORDS]+{selection+2,2})
       elsif key = dn then 
	  selection = limit(selection + 1,{1,length(items)})
	  MoveCursor(box[COORDS]+{selection+2,2})
       elsif key = ENTER then
	  exit
       end if
 end while                                                                 
 selecteditems = {}
 for i = 1 to length(items) do
     if items[i][2] = 'X' then
	selecteditems = append(selecteditems,items[i][5..length(items[i])]) 
     end if
 end for
 return selecteditems
end function                                                                      

global function RadioBox(sequence title, sequence items)
object box, selecteditems   
atom key, selection
 for i = 1 to length(items) do
     items[i] = "( ) "&items[i]
 end for
 box = GenericBox(title,items)
 DisplayHint("Select with up/dn arrows, toggle with spacebar, enter when finished")    
 key = -1  selection = 1
 MoveCursor(box[COORDS]+{selection+2,2})
 while key != 13 do
       key = get_key()
       if key = SP then   
	  if items[selection][2] = 'X' then
	    items[selection][2] = ' '
	  else items[selection][2] = 'X'
	    printcolor(box[COORDS]+{selection+2,1},box[COLORS],items[selection]) 
	  end if 
	  for i = 1 to length(items) do   
	    if i != selection then
	     items[i][2] = ' '-- reset all buttons
	     printcolor(box[COORDS]+{i+2,1},box[COLORS],items[i])
	     end if
	    end for 
	  printat(box[COORDS]+{selection+2,1},items[selection])                               
	  MoveCursor(box[COORDS]+{selection+2,2})
       elsif key = up then 
	  selection = limit(selection - 1,{1,length(items)})      
	  MoveCursor(box[COORDS]+{selection+2,2})
       elsif key = dn then 
	  selection = limit(selection + 1,{1,length(items)})
	  MoveCursor(box[COORDS]+{selection+2,2})
       elsif key = ENTER then
	  exit
       end if
 end while                                                                 
 selecteditems = {}
 for i = 1 to length(items) do
     if items[i][2] = 'X' then
	selecteditems = append(selecteditems,items[i][5..length(items[i])]) 
     end if
 end for
 return selecteditems
end function                                                                      

global function ListBox(sequence title, sequence items, atom start)
object box
atom key, current, fini, max, itemcount
 box = GenericBox(title,"")    
 key = -1  current = 1
 itemcount = length(items)
 max = box[SIZE][1] - 3
 for i = 1 to itemcount do
     items[i] = pad(items[i],box[SIZE][2])
 end for
 fini = itemcount
 fini = limit(fini,{1,itemcount})
 fini = limit(fini,{fini,max})
 cursor(NO_CURSOR)
 DisplayList(box[COORDS]+{2,1},box[COLORS],items[start..fini],start)
 while key != 27 do
    key = get_key()
    if key  = ESC then exit
    elsif key = ENTER then
	  exit
    elsif key = up then
	  current = limit(current - 1,{1,itemcount})
	  if current < start then
	     start = limit(start - 1,{1,itemcount})
	     fini = start + max - 1
	  end if   
	  DisplayList(box[COORDS]+{2,1},box[COLORS],items[start..fini],current-start+1)
	  
    elsif key = dn then
	  current = limit(current + 1,{1,itemcount})
	  if current > fini then
	  fini = limit(fini + 1,{1,itemcount})
	  start = fini - max + 1 
	  end if
	  DisplayList(box[COORDS]+{2,1},box[COLORS],items[start..fini],current-start+1)
    end if
 end while        
 cursor(UNDERLINE_CURSOR)
 return items[current]
end function


--Same as list box, but returns index, not selected item
global function ListBoxIndex(sequence title, sequence items, atom selected)
object box
atom key, current, fini, max, itemcount,start
integer cur_sel
 box = GenericBox(title,"")
 key = -1  current = 1
 cur_sel = 1
 start = 1
 itemcount = length(items)
 max = box[SIZE][1] - 3
 for i = 1 to itemcount do
     items[i] = pad(items[i],box[SIZE][2])
 end for
 fini = itemcount
 fini = limit(fini,{1,itemcount})
 fini = limit(fini,{fini,max})
 cursor(NO_CURSOR)
 
 --simulate key down until get to selected item
 if selected <= itemcount then
	while current != selected do
		current = limit(current + 1,{1,itemcount})
		cur_sel = current
		if current > fini then
			fini = limit(fini + 1,{1,itemcount})
			start = fini - max + 1
		end if
	end while
 end if
 
 --DisplayList(box[COORDS]+{2,1},box[COLORS],items[start..fini],start)
 DisplayList(box[COORDS]+{2,1},box[COLORS],items[start..fini],current-start+1)
 while key != 27 do
    LIST_KEY = 0
    key = get_key()
    if key  = ESC then 
	cur_sel = -1
	exit
    elsif key = ENTER then
	  exit
    elsif key = up then
	  current = limit(current - 1,{1,itemcount})
	  cur_sel = current
	  if current < start then
	     start = limit(start - 1,{1,itemcount})
	     fini = start + max - 1
	  end if
	  DisplayList(box[COORDS]+{2,1},box[COLORS],items[start..fini],current-start+1)

    elsif key = dn then
	  current = limit(current + 1,{1,itemcount})
	  cur_sel = current
	  if current > fini then
	    fini = limit(fini + 1,{1,itemcount})
	    start = fini - max + 1
	  end if
	  DisplayList(box[COORDS]+{2,1},box[COLORS],items[start..fini],current-start+1)

    elsif key > 31 and key <129 then 
	 LIST_KEY = key
	 exit
    end if
 end while
 cursor(UNDERLINE_CURSOR)

 return cur_sel
end function

global function Input (sequence title, sequence prompt, sequence default)
sequence result, pcoords, icoords, box
atom key,i,imax, imode, max
  box = GenericBox(title,prompt)
  pcoords = get_position()
  icoords = pcoords       
  max = length(default)
  printcolor(icoords,{box[COLORS][2],box[COLORS][1]},default)   
  DisplayHint("Edit this field, press enter when done, or ESC to cancel")
  MoveCursor(icoords)
  result = default
  key = -1 i = 0 imax = length(default) imode = 0
  while key != 13 do
    key = get_key() 
    if key != -1 then 
       if key = ENTER then exit     
       elsif key = ESC then result = default exit
       elsif key = bksp then -- backspace
	     if i > 0 then            
		result = delete(result,i,1) & ' '
		printat(icoords,result)          
		imax = length(result)
		i = i - 1   
	     end if   
       elsif key = left then i = limit(i-1,{0,max}) -- left arrow
       elsif key = right then i = limit(i+1,{0,max}) -- right arrow
       elsif key = home then i = 0 -- home
       elsif key = endd then i = max-1 -- end
       elsif key = insert then     -- INS key
	     imode = not(imode) -- toggle insert mode
	     if imode = 1 then cursor(BLOCK_CURSOR)
	     else cursor(UNDERLINE_CURSOR)
	     end if  
      elsif key > 31 and key < 129 then
	     
       if imode then
	    i = limit(i+1,{1,max})
	    result[i] = key  
	    else  
	    result = result[1..i] & key & result[i+1..length(result)]
	    result = result[1..max]
	    i = limit(i+1,{1,max})
	    end if
     end if    
       printcolor(icoords,{box[COLORS][2],box[COLORS][1]},result)
       position(icoords[1],icoords[2]+i)
   end if
  end while 
  RestoreBkgnd(box)
return result
end function

global procedure Progress(sequence title, sequence msg, atom percent)
object box, pbar
 box = GenericBox(title,{msg})
 pbar = repeat('',box[SIZE][COL] - 4)
 MoveCursor(box[COORDS]+{5,2})
 puts(1,pbar)                       
 pbar = repeat('',length(pbar) * percent * .01)
 MoveCursor(box[COORDS]+{5,2})
 puts(1,pbar)
end procedure

global procedure Delay(atom sec)
object start, fini
 start = time()    
 fini = start + sec
 while time() < fini do
 end while   
end procedure


------------------------------------------------------------------------------------------------------------------------
global function Form(sequence title, sequence fields)
--fields is a sequence of THREES of sequences, 
--holding the label, input field, and length of input field
--most of this is based on the Input function

sequence result, box, field_coords, pcoords, input_field 
integer  j, lines, field_count, size_x, size_y, start_field
integer  max_field_length, current_field, curs_posn
atom key, cur_style, field_change, imode
	key =0
	field_change = 0

result = {}
pcoords = get_position()

--calculate number of lines (1 line = 1 label + 1 field)
field_count = length(fields)
lines = field_count/3

--find max_field_length
max_field_length = 0
for i = 3 to field_count by 3 do
    if fields[i] > max_field_length then
	max_field_length = fields[i]
    end if
end for

--set box size
size_x = lines+3
--size_y = length(fields[1])  + length(fields[2]) + 4
    -- 1st 2 fields set width of box - all other fields should be same size
size_y = length(fields[1]) + max_field_length + 4
start_field = length(fields[1]) + 2
SetSize(size_x, size_y)

--create box
box = GenericBox(title, {})

--create labels & fields
for i = 1 to field_count by 3 do
    printcolor(box[COORDS]+{3+i/3, 1}, {box[COLORS][1], box[COLORS][2]},fields[i])
    input_field = repeat(' ', fields[i+2])
    printcolor(box[COORDS]+{3+i/3, 1+start_field}, {WHITE, BLACK}, input_field)
    printat(box[COORDS]+{3+i/3, 1+start_field}, fields[i+1])
    --Note - entry fields always white on black
end for

--position cursor in 1st entry field, and start entry loop
current_field = 1 --remember, sets of 3!
curs_posn = 1
imode = 1 -- start on overwrite
MoveCursor(box[COORDS]+{3+current_field/3, 1+start_field})

--input_field now becomes the buffer
input_field = fields[1 + 1] --ie first field

while length(input_field) < 3 do
    input_field = input_field & ' '
end while


while key != ESC do
	key = get_key()
	if key > 0 then -- do nothing if no key pressed - faster key scanning, and cursor flashing
	    
	    if key = dn or key = ENTER then
		field_change = 1
		--write out buffer
		fields[current_field+1] = input_field
		current_field = current_field+3
		if current_field > field_count then current_field = current_field-3 end if
		input_field = fields[current_field+1]
		if length(input_field) < 3 then
		    input_field = input_field & "   "
		end if
	    
	    elsif key = up then
		field_change = 1
		--write out buffer
		fields[current_field+1] = input_field               
		current_field = current_field-3
		if current_field < 0 then current_field = current_field+3 end if
		input_field = fields[current_field+1]
		if length(input_field) < 3 then
		    input_field = input_field & "   "
		end if
		
	    elsif key = home then
		current_field = 1
		field_change = 1
	
	    elsif key = right then
		curs_posn = curs_posn + 1
		if curs_posn > fields[current_field+2] then
		    curs_posn = curs_posn - 1
		end if
	
	    elsif key = left then
		curs_posn = curs_posn - 1
		if curs_posn = 0 then
		    curs_posn = 1               
		end if
	
	    elsif key = bksp then
		if curs_posn > 1  and  curs_posn <= length(input_field) then
		    curs_posn = curs_posn -1
		    input_field = input_field[1..curs_posn-1] & input_field[curs_posn+1..length(input_field)] & ' '
		
		end if
	    
	    elsif key = insert then
		imode = not(imode)
		if imode = 1  then cursor(BLOCK_CURSOR)
		else cursor(UNDERLINE_CURSOR)               
		end if          
		
	    elsif key > 31 and key <129 then
		if imode then
		    if curs_posn > length(input_field) then
			curs_posn = length(input_field)+1
			input_field = input_field & key
		    else
			input_field[curs_posn] = key                    
		    end if
		    curs_posn = curs_posn +1
		else
		    input_field = input_field[1..curs_posn-1] & key & input_field[curs_posn .. length(input_field)]
		    curs_posn = curs_posn +1
		    if length(input_field) > fields[current_field+2] then
			input_field = input_field[1..fields[current_field+2]]
		    end if
		
		end if          
		if curs_posn > fields[current_field+2] then
		    curs_posn = curs_posn - 1
		end if
	    end if      
	
	    if field_change = 1 then
		field_change = 0
		MoveCursor(box[COORDS]+{3+current_field/3, 1+start_field})
		curs_posn = 1
			    
	    end if

	    
	    --refresh the current field
	    printcolor(box[COORDS]+{3+current_field/3, 1+start_field}, {WHITE, BLACK}, input_field)
	    --move the cursor back to its set position
	    MoveCursor(box[COORDS] + {3+current_field/3, start_field + curs_posn})
	end if

end while

--write out last filed
fields[current_field+1] = input_field

--clear the box
SetSize(size_x, size_y)
position(pcoords[1],pcoords[2])
SetColors(SCREEN_BKGND, SCREEN_BKGND)
cur_style = DefaultBox[STYLE]
DefaultBox[STYLE] = 5
box = GenericBox({}, {})
DefaultBox[STYLE] = cur_style

for i =2  to field_count  by 3 do
    result = append(result, fields[i] )
end for

return result 

end function 
