-- Linux File I/O Library version 1.0 by Jeffrey Fielding (JJProg@cyberbury.net)
-- Allows access to files through C FILE * pointers. Also allows block
-- file reading and writing, which should be much faster than using getc etc.
include dll.e
include machine.e
constant STDLIB = open_dll("")
constant FOPEN = define_c_func(STDLIB,"fopen",{C_POINTER,C_POINTER},C_POINTER)
constant FCLOSE = define_c_func(STDLIB,"fclose",{C_POINTER},C_INT)
constant FGETC = define_c_func(STDLIB,"fgetc",{C_POINTER},C_INT)
constant FPUTC = define_c_func(STDLIB,"fputc",{C_INT,C_POINTER},C_INT)
constant FREAD = define_c_func(STDLIB,"fread",{C_POINTER,C_INT,C_INT,C_POINTER},C_INT)
constant FWRITE = define_c_func(STDLIB,"fwrite",{C_POINTER,C_INT,C_INT,C_POINTER},C_INT)
global function fopen(sequence file, sequence mode)
    atom fl, md, r
    fl = allocate_string(file)
    md = allocate_string(mode)
    r = c_func(FOPEN,{fl,md})
    if r = 0 then
	r = -1
    end if
    free(fl)
    free(md)
    return r
end function
global procedure fclose(atom fl)
    integer r
    r = c_func(FCLOSE,{fl})
end procedure
global function fgetc(atom fl)
    return c_func(FGETC,{fl})
end function
global procedure fputc(atom fl, integer c)
    integer r
    r = c_func(FPUTC,{c,fl})
end procedure
global procedure fwrite(atom fl, sequence x)
    atom m, r
    m = allocate_string(x)
    r = c_func(FWRITE,{m,1,length(x),fl})
    free(m)
end procedure
global procedure fwritemem(atom fl, atom m, atom len)
    atom r
    r = c_func(FWRITE,{m,1,len,fl})
end procedure
global function fread(atom fl, atom len)
    atom m, r
    sequence s
    m = allocate(len)
    r = c_func(FREAD,{m,1,len,fl})
    s = peek({m,r})
    free(m)
    return s
end function
global function freadmem(atom fl, atom len, atom m)
    return c_func(FREAD,{m,1,len,fl})
end function
